import("./utils.js").then((utils) => {
  import(utils.coreVersion()).then((core) => {

    core.Sib.register({
      name: "solid-tzcld-menuxxx",
      use: [core.StoreMixin],

      empty() {
        this.element.innerHTML = `<solid-link
              class="segment sm-full button text-xsmall text-bold text-uppercase text-center reversed color-secondary bordered button-icon icon icon-plus icon-margin-right-xsmall"
              next="tzcld-answers">
              Answers
            </solid-link>`;
      },

      async populate() {
        this.element.innerHTML = `
        <div
          class="loader">
          <div></div>
          <div></div>
          <div></div>
          <div></div>
        </div>`;

        let render = "";

          render = `
            <solid-link
              class="segment sm-full button text-xsmall text-bold text-uppercase text-center reversed color-secondary bordered button-icon icon icon-plus icon-margin-right-xsmall"
              next="tzcld-answers">
              Answers
            </solid-link>
          `;

        this.element.innerHTML = render;
      },
    });
    customElements.define(
      "solid-tzcld-menu",
      class extends core.SolidTemplateElement {
        constructor() {
          super();
          utils.setupOrbit(this);
        }

        static get propsDefinition() {
          return {
            //uniqCommunity: "uniq-community",
            uniq: "uniq",
          };
        }

        viewMenu() {
          let render = `
          <solid-route class="menu-header segment full padding-xsmall text-semibold text-color-white bg-color-heading transparent-background hover cursor-pointer jsMenuHeader"  name="tzcld">
            <div
              class="segment half text-uppercase text-letter-spacing-large">
              Answers
            </div>
          </div>`;

          return render;
        }

        template(props) {
          this.uniq = props.uniq || utils.uniq();

          console.table(props);

          let render = `
            ${this.viewMenu()}
          `;

          return render;
        }
      }
    );


    core.Sib.register({
            name: "tzcld-point-answer-form",
            use: [core.StoreMixin],
      
            empty() {
              console.debug();
              this.element.innerHTML = "";
            },
      
            async populate() {
              this.element.innerHTML = `
              <div class="loader">
                <div></div>
                <div></div>
                <div></div>
                <div></div>
              </div>`;
              let tzcldprofile = {
                community: await this.resource,

              };


              if("label" in this.element.attributes) {
                for(let ignore of this.element.attributes['label'].value.split(',')) {
                  tzcldprofile[ignore.trim()] = null;
                }
              }
              let render = `
              <solid-form solid-resource bind-resources fields="answer"
              widget-answer="checkbox"
              ></solid-form>`;
              this.element.innerHTML = render;
            }
    });


    core.Sib.register({
            name: "tzcld-autoeval-points",
            use: [core.StoreMixin],
      
            empty() {
              console.debug();
              this.element.innerHTML = "";
            },
      
            async populate() {
              this.element.innerHTML = `
              <div class="loader">
                <div></div>
                <div></div>
                <div></div>
                <div></div>
              </div>`;
              let tzcldprofile = {
                points: await this.resource["ldp:contains"]
              };
              let parentContext = utils.findAncestor(this.element, 'tzcld-autoeval') ;
              let communityId = parentContext.getAttribute('data-src') ;
              let pointsAnswers = parentContext.getAttribute('point-answers') ;

              let render = ``;
              let i = 0 ;
              
              for(let point of tzcldprofile.points) {
                render +=  ` <div class="full">
                  <solid-form-search id="filter-anwer-${utils.getIntId(point['@id'])}" class="hidden"
                  fields="community, evaluation_point"
                  value-community="${communityId}"
                  value-evaluation_point="${point['@id']}"
                  ></solid-form-search>
                  <solid-display 
                    solid-resource 
                    bind-resources 
                    fields="@id" 
                    filtered-by="filter-anwer-${utils.getIntId(point['@id'])}"  
                    data-src="${pointsAnswers}" 
                    widget-id="autoeval-answer-form"
                  ></solid-display>
                  </div>`;
                i++ ;
              }
              this.element.innerHTML = render;
            }
    });

    core.Sib.register({
            name: "tzcld-autoeval",
            use: [core.StoreMixin],
      
            empty() {
              console.debug();
              this.element.innerHTML = "";
            },
      
            async populate() {
              this.element.innerHTML = `
              <div class="loader">
                <div></div>
                <div></div>
                <div></div>
                <div></div>
              </div>`;
              let tzcldprofile = {
                community: await this.resource,
                name: await this.resource.name,
                parts: await this.element.getAttribute('parts'),
              };

              if("label" in this.element.attributes) {
                for(let ignore of this.element.attributes['label'].value.split(',')) {
                  tzcldprofile[ignore.trim()] = null;
                }
              }
              let render = `
          <solid-widget name="autoeval-answer-comment-form">
            <template>
            <div class="\${value != "" ? \`not-null\` : \`null\`}">
              <solid-form-textarea name="comment" class="segment auto" value=\${value}">
                <textarea data-holder="" name="comment"><!---->\${value}<!----></textarea>
              </solid-form-textarea>
              <div class="segment full display-comment">
                <div class="segment auto">\${value}</div>
                <div class="search-button segment auto text-xsmall children-link-button children-link-text-bold children-link-text-uppercase children-link-reversed color-secondary bordered children-button-icon children-icon-arrow-right-circle children-icon-small children-icon-margin-right-xsmall text-right padding-right-xsmall padding-left-xsmall block">
                  <button><!---->Modifier<!----></button>
                </div>
              </div>
            </div>
            </template>
          </solid-widget>
          <solid-widget name="autoeval-answer-form">
            <template>
            <div class="segment full auto-eval-answer">
            <div class="segment half padding-small">
            <div class="segment auto padding-small text-top">
              <solid-form solid-resource bind-resources fields="answer" data-src="\${value}"
              widget-answer="solid-form-checkbox"
              label-answer=" "
              class-submit-button="hidden"
              autosave
              ></solid-form>
              </div>
              <div class="segment auto padding-small text-top whitespace-normal">
              <solid-display  data-src="\${value}"
                solid-resource 
                bind-resources 
                fields="evaluation_point.name"  
                widget-evaluation_point.name="span"
              ></solid-display>
              </div>
              </div>
              <div class="segment half padding-small text-top">
              <solid-display
                  data-src="\${value}"
                  fields="comment"
                  widget-comment="solid-display-div"
                  editable-comment
              ></solid-display>
              </div>
              </div>
            </template>
          </solid-widget>
              <div>${await tzcldprofile.name}</div>
              <solid-display solid-resource bind-resources data-src="${this.element.getAttribute('parts')}" parts-points="${this.element.getAttribute('parts-points')}" fields="title, subtitle,  part_points" class="segment full"
              multiple-part_points="tzcld-autoeval-points"
              widget-name="div"
              widget-title="h2"
              widget-subtitle="div"
              class-title="margin-large margin-left-small text-xlarge text-xbold text-color-heading"
              class-subtitle="tzcld-h2 margin-left-small text-xlarge"
              class-part_points="full"
              ></solid-display>`;

             
              this.element.innerHTML = render;
            }
    });
    customElements.define(
      "solid-tzcld",
      class extends core.SolidTemplateElement {
        constructor() {
          super();
          this.setTranslationsPath(`${utils.path()}/locales`);
          utils.setupOrbit(this);
        }

        static get propsDefinition() {
          return {
            //uniqCommunity: "uniq-community",
            parts: "parts",
            partsPoints: "parts-points",
            pointAnswers: "point-answers",
            communities: "communities",
          };
        }

        routeurs() {
          let render = `
          <solid-router default-route="${this.route}-my-communities">
            <solid-route name="${this.route}-answers" use-id></solid-route>
            <solid-route name="${this.route}-my-communities"></solid-route>
          </solid-router>
          `;

          return render;
        }

        viewWidgets() {
          let render = ``;
          return render;
        }

        viewMyCommunities() {


          let render = `
            <div id="${this.route}-my-communities" data-view="${this.route}-my-communities" class="tzcld-my-communities">
              <div class="segment full padding-large border-bottom border-color-grey" style="padding-top: 0;">
                <div class="segment full sm-hidden text-right">
                  <solid-link class="backlink" next="${this.route}-community-profile">${this.localize("back")}</solid-link>
                </div>
              </div>

              <div class="segment block shadow bg-color-white margin-right-xxsmall margin-left-xxsmall sm-margin-none">

                <div class="loader" id="loader-${this.route}-my-communities">
                  <div></div>
                  <div></div>
                  <div></div>
                  <div></div>
                </div>

                <solid-display 
                  bind-resources=""
                  loader-id="loader-${this.route}-my-communities"
                  data-src ="${this.communities}"
                  fields="name"
                  next="${this.route}-answers"

                `;

            render += `>
                </solid-display>`;
            

          render += `
            </div>
          </div>`;
          return render;
        }
        viewCommunityAnswers() {


          let render = `
            <div id="${this.route}-answers" data-view="${this.route}-answers" class="community-answers">
              <div class="segment full padding-large border-bottom border-color-grey" style="padding-top: 0;">
                <div class="segment full sm-hidden text-right">
                  <solid-link class="backlink" next="${this.route}-community-profile">${this.localize("back")}</solid-link>
                </div>
              </div>

              <div class="segment block shadow bg-color-white margin-right-xxsmall margin-left-xxsmall sm-margin-none">

                <div class="loader" id="loader-${this.route}-answer">
                  <div></div>
                  <div></div>
                  <div></div>
                  <div></div>
                </div>

                <tzcld-autoeval 
                  class="tzcld-autoeval"
                  bind-resources=""
                  loader-id="loader-${this.route}-answer"
                  parts ="${this.parts}"
                  parts-points ="${this.partsPoints}"
                  point-answers ="${this.pointAnswers}"
                  solid-resource
                `;

            render += `>
                </tzcld-autoeval>`;
            

          render += `
            </div>
          </div>`;
          return render;
        }

        template(props) {
          this.uniq = props.uniq || utils.uniq();
          this.parts = props.parts;
          this.partsPoints = props.partsPoints;
          this.pointAnswers = props.pointAnswers;
          this.communities = props.communities ;

          console.table(props);

          this.route = this.getRoute(this.uniq);

          let render = `
            ${this.routeurs()}
            ${this.viewWidgets()}
            ${this.viewCommunityAnswers()}
            ${this.viewMyCommunities()}
          `;

          return render;
        }

        _camelize(str) {
          return str.replace(/[-]+(.)/g, (match, chr) => chr.toUpperCase());
        }

        _uncamelize(str) {
          return str.replace(
            /[A-Z]+/g,
            (match, chr) => "-" + match.toLowerCase()
          );
        }
      }
    );
  });
});
